//+------------------------------------------------------------------+
//|                                                 TagsFromHTML.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.ru/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.ru/"

#property show_inputs
#property stacksize 1000000
extern string filename = "StrategyTester.htm";

//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
void PrintStringArray(string array[],string nameOfArray)
   {
//----
   Print(" ",nameOfArray);
   for (int i = 0; i < ArraySize(array); i++)
      {
      Print(i, ":", array[i]);
      }
   Print("  ");
//----
   return;      
   }

//+------------------------------------------------------------------+
//|       array[]                  |
//|     false                                    |
//+------------------------------------------------------------------+
bool ReadFileToArray(string & array[], string FileName, string WorkFolderName)
  {
   bool res = false;
   int FileHandle;
   string tempArray[64000], currString;
   int stringCounter;
   int devider = '\x90';
   string FullFileName;
   if (StringLen(WorkFolderName) > 0) FullFileName = StringConcatenate(WorkFolderName, "\\", FileName);
   else FullFileName = FileName;
//----
   Print("   ", FileName);
   FileHandle=FileOpen(FullFileName, FILE_READ, devider);
   if (FileHandle != -1)
      {
      while(!FileIsEnding(FileHandle)) 
         {
         tempArray[stringCounter] = FileReadString(FileHandle);
         stringCounter++;
         }
      stringCounter--;
      if (stringCounter > 0) 
         {
         ArrayResize(array,stringCounter);
         for (int i = 0; i < stringCounter; i++) array[i] = tempArray[i];
         res = true;
         }
      FileClose(FileHandle);   
      }
   else
      {
      Print("    ", FileName);
      }      
//----
   return(res);
  }

//+------------------------------------------------------------------+
//|       matchedText      |
//+------------------------------------------------------------------+
void FindInArray(string Array[],          //  ,    matchedText
                 int inputLine,           //  ,    
                 int inputPos,            //  ,    
                 int & returnLineNumber,  //    ,   
                 int & returnPosIndex,    //    
                 string matchedText       //  
                 )
   {
   int start;
   returnLineNumber = -1;
   returnPosIndex = -1;
   int pos;
//----
   for (int i = inputLine; i < ArraySize(Array); i++)
      {
      if (i == inputLine) start = inputPos; else start = 0;
      if (start >= StringLen(Array[i])) start = StringLen(Array[i])-1;
      pos=StringFind(Array[i], matchedText, start);
      if (pos !=- 1)
         {
         returnLineNumber = i;
         returnPosIndex = pos;
         break;
         }
      }   
//----
   return;   
   }

//+------------------------------------------------------------------+
//|                          |
//+------------------------------------------------------------------+
string getTagFromArray(string inputArray[],  //    
                       int lineOpen,         //    
                       int posOpen,          //   
                       int lineClose,        //    
                       int posClose,         //    
                       int line_,            //  
                       int pos_)             //  
   {
   string res = "";
//----
   if (ArraySize(inputArray)==0) 
      {
      Print("     getTagFromArray()");
      return(res);   
      }
   string currString;
   int endLine = -1;
   int endPos = -1;
   if (lineClose >= 0 && line_ >= 0)  //      
      {
      endLine = MathMin(lineClose,line_); //    
      if (lineClose == line_ && pos_ < posClose) endPos = pos_;
      //         -    
      
      if (lineClose == line_ && pos_ > posClose) endPos = posClose;
      //         -     
      
      if (lineClose > line_)  endPos = pos_;
      //          -    
      
      if (lineClose < line_)  endPos = posClose;
      //          -     
      }
   if (lineClose >= 0 && line_ < 0)  //  
      {
      endLine=lineClose;
      endPos=posClose;
      }

   for (int i = lineOpen; i <= endLine; i++)
      {
      if (i == lineOpen && lineOpen != endLine) //      
         {
         currString = inputArray[i];
         res = StringConcatenate(res, StringSubstr(currString, posOpen));
         }
      if (i == lineOpen && lineOpen == endLine) //  
         {
         currString = inputArray[i];
         res = StringConcatenate(res, StringSubstr(currString, posOpen, endPos-posOpen));
         }
      if (i > lineOpen && i < endLine)         //   
         {
         res = StringConcatenate(res, inputArray[i]);
         }               
      if (i == endLine && endLine > lineOpen)   //    
         {
         currString = inputArray[i];
         if (endPos > 0) res=StringConcatenate(res, StringSubstr(currString, 0, endPos));
         }               
      }
   if (StringLen(res) > 0) res = res + ">";   
//----
   return(res);   
   }
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
void FillTagStructure(string  & structure[],//   
                      int     & start[][],  //   (, )
                      int     & end[][],    //   (, )
                      string  array[],      //  html-
                      int     line,         //    array[]
                      int     pos)          //     line
   {
//----
   int array_Size = ArraySize(array);

   
   if (line == -1000 || pos == -1000 )
      {
      Alert("      FillTagStructure()");
      return;
      }
      
   string currString="", newTag="";
   int size = ArraySize(array), structureSize = ArraySize(structure);

   if (size == 0)
      {
      Alert("        FillTagStructure()");
      return;
      }
   int newLine = -1000, newPos = -1000;
   bool tagFounded = false;
   int lineOpen, posOpen, lineClose, posClose, line_, pos_; 
   FindInArray(array,line, pos, lineOpen, posOpen, "<");
   
   if (lineOpen != -1 && posOpen != -1)
      {
      FindInArray(array, lineOpen, posOpen+1, lineClose, posClose, ">");
      FindInArray(array, lineOpen, posOpen+1, line_, pos_, " ");
      if (lineClose != -1) //   
         {
         newTag = getTagFromArray(array, lineOpen, posOpen, lineClose, posClose, line_, pos_);
         newLine = lineClose;
         newPos = posClose+1;
         tagFounded = true;
         }
      else
         {
         Print("      FillTagStructure()" );
         return;
         }   
      }

   if (tagFounded)
      {
      ArrayResize(structure, structureSize+1);
      structure[structureSize] = newTag;
      
      ArrayResize(start, structureSize+1);
      start[structureSize][0] = lineOpen;
      start[structureSize][1] = posOpen;
      
      ArrayResize(end, structureSize+1);
      end[structureSize][0] = lineClose;
      end[structureSize][1] = posClose + 1;
      
      FillTagStructure(structure, start, end, array, newLine, newPos);
      }
//----
   return;   
   }
  
//+------------------------------------------------------------------+
//|                         |
//+------------------------------------------------------------------+
string GetContent(string array[], int start[1][2],int  end[1][2])
   {
   string res = "";
//----
   int startLine = start[0][0];
   int startPos = start[0][1];

   int endtLine = end[0][0];
   int endPos = end[0][1];
   string currString;
   
   for (int i = startLine; i<=endtLine; i++)
      {
      currString = array[i];
      if (i == startLine && endtLine > startLine)
         {
         res = res + StringSubstr(currString, startPos);
         }
      if (i > startLine && i < endtLine)
         {
         res = res + currString;
         }
         
      if (endtLine > startLine && i == endtLine)
         {
         if (endPos > 0) res = res + StringSubstr(currString, 0, endPos);
         }
         
      if (endtLine == startLine && i == endtLine)
         {
         if (endPos - startPos > 0) res = res + StringSubstr(currString, startPos, endPos - startPos);
         }
      }
//----
   return(res);   
   }  
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
//----
   int i;
   string array[];

   ReadFileToArray(array, filename,"");
   
   int arraySize=ArraySize(array);
      
   string tags[];    //    
   int startPos[][2];//   
   int endPos[][2];  //   
   
   FillTagStructure(tags, startPos, endPos, array, 0, 0);
   //PrintStringArray(tags, "tags  ");
   int tagsNumber = ArraySize(tags);
   string text = "";
   string currTag;
   int start[1][2];
   int end[1][2];

   for (i = 0; i < tagsNumber; i++)
      {
      currTag = tags[i];
      //Print(tags[i],"\t\t  start pos=(",startPos[i][0],",",startPos[i][1],") \t end pos = (",endPos[i][0],",",endPos[i][1],")");

      if (currTag == "<table>")
         {
         Print(" ");
         }

      if (currTag == "<tr>")
         {
         text = "";
         start[0][0] = -1;
         start[0][1] = -1;
         
         }

      if (currTag == "<td>")
         {//        
         start[0][0] = endPos[i][0];
         start[0][1] = endPos[i][1];
         }

      if (currTag == "</td>")
         {//        
         end[0][0] = startPos[i][0];
         end[0][1] = startPos[i][1];
         }

      if (currTag == "</td>")
         {//        
         end[0][0] = startPos[i][0];
         end[0][1] = startPos[i][1];
         text = text + GetContent(array, start, end) + ";";
         }

      if (currTag == "</tr>")
         {
         Print(text);
         }

      if (currTag == "</table>")
         {
         Print(" ");
         }

      }
//----
   return(0);
  }
//+------------------------------------------------------------------+